package ad.creuroja.gestio.interceptors;

import java.io.IOException;

import com.achavero.cvf.core.CvfInterceptor;
import com.achavero.cvf.core.CvfRequestInvocation;

/**
 * Interceptor que comprueba si tenemos sesión loggeada
 * Comprueba que el exista el atributo de sesión loggedAsUsername:
 * Si no existe es que no hicimos login, y redirecciona a la pantalla de login
 * Si existe ya hicimos login y por lo tanto podemos continuar con la petición
 * @author Adrian Chavero Ramos
 * @version 20 de dic. de 2015
 */
public class LoggedInterceptor extends CvfInterceptor {

	@Override
	public boolean interceptPreProcess(CvfRequestInvocation invocation) {
		String loggedAsUsername = (String)invocation.getRequest().getSession().getAttribute("loggedAsUsername");
		if (loggedAsUsername==null || loggedAsUsername.equals("")) {
			try {
				invocation.getResponse().sendRedirect("login.view");
				return false;
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return true;
	}

	@Override
	public void interceptPostProcess(CvfRequestInvocation invocation) {

	}

}
