package ad.creuroja.gestio.models;

import com.achavero.cvf.views.ColumnData;

/**
 * Entity login
 * JavaBean con la información de los usuarios que pueden hacer login en la aplicación
 * @author Adrian Chavero Ramos
 * @version 20 de dic. de 2015
 */
public class Login {

	private Long id;

	protected String username;
	protected String password;
	protected String email;
	protected String name;
	protected String surname;

	public Login() {
		this.username = "";
		this.password = "";
		this.email = "";
		this.name = "";
		this.surname = "";
	}

	public Login(String username, String password) {
		this.username = username;
		this.password = password;
		this.email = "";
		this.name = "";
		this.surname = "";
	}

	public Login(String username, String password, String email, String name, String surname) {
		super();
		this.username = username;
		this.password = password;
		this.email = email;
		this.name = name;
		this.surname = surname;
	}

	public Long getId() {
		return this.id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	@ColumnData(labelValue="Username")
	public String getUsername() {
		return this.username;
	}
	public void setUsername(String username) {
		this.username = username;
	}

	@ColumnData(labelValue="Password")
	public String getPassword() {
		return this.password;
	}
	public void setPassword(String password) {
		this.password = password;
	}

	@ColumnData(labelValue="Email")
	public String getEmail() {
		return this.email;
	}
	public void setEmail(String email) {
		this.email = email;
	}

	@ColumnData(labelValue="Nombre")
	public String getName() {
		return this.name;
	}
	public void setName(String name) {
		this.name = name;
	}

	@ColumnData(labelValue="Apellido")
	public String getSurname() {
		return this.surname;
	}
	public void setSurname(String surname) {
		this.surname = surname;
	}

}
