package ad.creuroja.gestio.requests;

import com.achavero.cvf.core.CvfRequestCommand;
import com.achavero.cvf.core.CvfRequestInvocation;

import ad.creuroja.gestio.services.impl.LoginServiceImpl;

/**
 * Acción de intento de login
 * post desde login.view
 * success -> main.view
 * failed -> /main/login.jsp
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class LoginAction extends CvfRequestCommand {

	@Override
	public String execute(CvfRequestInvocation invocation) {

		String username = invocation.getRequest().getParameter("username");
		String password = invocation.getRequest().getParameter("password");

		LoginServiceImpl loginService = new LoginServiceImpl();

		boolean logged = loginService.login(username, password);

		if (logged) {
			invocation.getRequest().getSession().setAttribute("loggedAsUsername", username);
			return "success";
		} else {
			invocation.getRequest().setAttribute("error_message", "Login o password incorrectos");
			return "failed";
		}

	}
}
