package ad.creuroja.gestio.requests.administration;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.beanutils.BeanUtils;

import com.achavero.cvf.core.CvfRequestCommand;
import com.achavero.cvf.core.CvfRequestInvocation;
import com.achavero.utils.Utils;

import ad.creuroja.gestio.models.Login;
import ad.creuroja.gestio.services.impl.LoginServiceImpl;

/**
 * Acción de gestión de Login.
 * Añadir, modificar Login
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class LoginAddModAction extends CvfRequestCommand {

	@Override
	public String execute(CvfRequestInvocation invocation) {

		HttpServletRequest request = invocation.getRequest();

		Boolean modification = Utils.getParameter(request, "modification", false);

		Login login = new Login();

		try {
			BeanUtils.populate(login, request.getParameterMap());
		} catch (IllegalAccessException | InvocationTargetException e) {
			e.printStackTrace();
		}

		LoginServiceImpl loginService = new LoginServiceImpl();

		if (modification) {
			if (login.getUsername() == null || login.getUsername().equals("")) {
				request.setAttribute("login", login);
				request.setAttribute("modification", true);
				request.setAttribute("error_message", "Username es campo obligatorio");
				return "errorMod";
			}
			boolean modified = loginService.modLogin(login);
			if (modified) {
				request.setAttribute("login", login);
				request.setAttribute("modification", true);
				request.setAttribute("success_message", "Modificado correctamente");
				return "successMod";
			}
		} else {
			if (login.getUsername() == null || login.getUsername().equals("") || login.getPassword() == null
					|| login.getPassword().equals("")) {
				request.setAttribute("error_message", "Username y password son campos obligatorios");
				return "errorAdd";
			}
			boolean added = loginService.addLogin(login);

			if (added) {
				return "successAdd";
			} else {
				request.setAttribute("error_message", "Este Username ya existe.");
				return "errorAdd";
			}
		}
		return "";
	}
}
