package ad.creuroja.gestio.requests.administration;

import com.achavero.cvf.core.CvfRequestCommand;
import com.achavero.cvf.core.CvfRequestInvocation;
import com.achavero.utils.Utils;

import ad.creuroja.gestio.models.Login;
import ad.creuroja.gestio.services.impl.LoginServiceImpl;

/**
 * Comando para la vista modificación de Login
 * success -> /administration/loginAddMod.jsp
 * error -> loginList.view
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class LoginModView extends CvfRequestCommand {

	@Override
	public String execute(CvfRequestInvocation invocation) {

		Login login = Utils.getAttribute(invocation.getRequest(), "login", null, Login.class);
		if (login!=null) {
			invocation.getRequest().setAttribute("login", login);
			invocation.getRequest().setAttribute("modification", true);
			return "success";
		}

		Long idSelected = Utils.getParameter(invocation.getRequest(), "idSelected", -1L, Long.class);

		if (idSelected==null || idSelected==-1L) {
			return "error";
		}

		LoginServiceImpl loginService = new LoginServiceImpl();
		login = loginService.get(idSelected);

		if (login!=null) {
			invocation.getRequest().setAttribute("login", login);
			invocation.getRequest().setAttribute("modification", true);
			return "success";
		} else {
			return "error";
		}
	}

}
