package ad.creuroja.gestio.requests.teleAssist;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.BeanUtilsBean;

import com.achavero.cvf.core.CvfRequestCommand;
import com.achavero.cvf.core.CvfRequestInvocation;

import ad.creuroja.gestio.models.TeleAssistUser;
import ad.creuroja.gestio.services.impl.TeleAssistUserServiceImpl;

/**
 * Acción añadir un usuario de teleasistencia
 * success -> /teleAssist/teleAssistAddMod.jsp
 * error -> teleAssistUserList.view
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class TeleAssistUserAddAction extends CvfRequestCommand {

	@Override
	public String execute(CvfRequestInvocation invocation) {

		HttpServletRequest request = invocation.getRequest();

		TeleAssistUser teleAssistUser = new TeleAssistUser();

		BeanUtilsBean.getInstance().getConvertUtils().register(false, false, 0);
		try {
			BeanUtils.populate(teleAssistUser, request.getParameterMap());
		} catch (IllegalAccessException | InvocationTargetException e) {
			e.printStackTrace();
		}

		TeleAssistUserServiceImpl teleAssistUserService = new TeleAssistUserServiceImpl();

		boolean added = teleAssistUserService.addTeleAssistUser(teleAssistUser);

		if (added) {
			return "success";
		} else {
			request.setAttribute("error_message", "Error al guardar.");
			return "error";
		}

	}
}
