package ad.creuroja.gestio.requests.teleAssist;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.BeanUtilsBean;

import com.achavero.cvf.core.CvfRequestCommand;
import com.achavero.cvf.core.CvfRequestInvocation;
import com.achavero.utils.Utils;

import ad.creuroja.gestio.models.TeleAssistUser;
import ad.creuroja.gestio.services.impl.TeleAssistUserServiceImpl;

/**
 * Acción de modificar un usuario de teleasistencia
 * success -> teleAssistUserList.view
 * error -> /teleAssist/teleAssistAddMod.jsp
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class TeleAssistUserModAction extends CvfRequestCommand {

	@Override
	public String execute(CvfRequestInvocation invocation) {

		HttpServletRequest request = invocation.getRequest();

		Boolean modification = Utils.getParameter(request, "modification", false);

		TeleAssistUser teleAssistUser = new TeleAssistUser();

		BeanUtilsBean.getInstance().getConvertUtils().register(false, false, 0);
		try {
			BeanUtils.populate(teleAssistUser, request.getParameterMap());
		} catch (IllegalAccessException | InvocationTargetException e) {
			e.printStackTrace();
		}

		TeleAssistUserServiceImpl teleAssistUserService = new TeleAssistUserServiceImpl();

		boolean modified = teleAssistUserService.modTeleAssistUser(teleAssistUser);

		if (modified) {
			request.setAttribute("teleAssistUser", teleAssistUser);
			request.setAttribute("modification", true);
			request.setAttribute("success_message", "Modificado correctamente");
			return "success";
		}

		return "error";

	}
}
