package ad.creuroja.gestio.requests.teleAssist;

import com.achavero.cvf.core.CvfRequestCommand;
import com.achavero.cvf.core.CvfRequestInvocation;
import com.achavero.utils.Utils;

import ad.creuroja.gestio.models.TeleAssistUser;
import ad.creuroja.gestio.services.impl.TeleAssistUserServiceImpl;

/**
 * Comando de vista de modificación de usuario de teleasistencia
 * success -> /teleAssist/teleAssistUserAddMod.jsp
 * error -> teleAssistUserList.view
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class TeleAssistUserModView extends CvfRequestCommand {

	@Override
	public String execute(CvfRequestInvocation invocation) {

		TeleAssistUser teleAssistUser = Utils.getAttribute(invocation.getRequest(), "TeleAssistUser", null, TeleAssistUser.class);
		if (teleAssistUser!=null) {
			invocation.getRequest().setAttribute("teleAssistUser", teleAssistUser);
			invocation.getRequest().setAttribute("modification", true);
			return "success";
		}

		Long idSelected = Utils.getParameter(invocation.getRequest(), "idSelected", -1L, Long.class);

		if (idSelected==null || idSelected==-1L) {
			return "error";
		}

		TeleAssistUserServiceImpl teleAssistUserService = new TeleAssistUserServiceImpl();
		teleAssistUser = teleAssistUserService.get(idSelected);

		if (teleAssistUser!=null) {
			invocation.getRequest().setAttribute("teleAssistUser", teleAssistUser);
			invocation.getRequest().setAttribute("modification", true);
			return "success";
		} else {
			return "error";
		}
	}

}
