package ad.creuroja.gestio.utils;

import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;

/**
 * Clase de utilidad para manejar las sessiones de Hibernate
 * @author Adrian Chavero Ramos
 * @version 9 de ene. de 2016
 */
public class HibernateUtil {

    private static final SessionFactory sessionFactory = HibernateUtil.buildSessionFactory();

    private static SessionFactory buildSessionFactory() {
        try {
            // Create the SessionFactory from hibernate.cfg.xml
            return new Configuration().configure().buildSessionFactory();
        } catch (Throwable ex) {
            System.err.println("Initial SessionFactory creation failed." + ex);
            throw new ExceptionInInitializerError(ex);
        }
    }

    public static SessionFactory getSessionFactory() {
        return HibernateUtil.sessionFactory;
    }
}