package com.achavero.cvf.core;

/**
 * Clase de base para todos los interceptores
 * @author Adrian Chavero Ramos
 * @version 20 de dic. de 2015
 */
public abstract class CvfInterceptor {
	public void init() {};
	public void destroy(){};

	/**
	 * metodo que se ejecuta antes de la accin/comando
	 * el retorno determina si se aborta o continua con la peticin
	 * @param invocation
	 * @return true si la peticin continua con la invocacin, false si abortamos
	 */
	public abstract boolean interceptPreProcess(CvfRequestInvocation invocation);

	/**
	 * metodo que se ejecuta despues de la accin/comando
	 * @param invocation
	 */
	public abstract void interceptPostProcess(CvfRequestInvocation invocation);

	public String intercept(CvfRequestInvocation invocation) {

		if (!this.interceptPreProcess(invocation)) {
			return null;
		}

		String result = invocation.invoke();

		this.interceptPostProcess(invocation);

		return result;
	}
}
