package com.achavero.cvf.interceptors;

import com.achavero.cvf.core.CvfInterceptor;
import com.achavero.cvf.core.CvfRequestInvocation;

/**
 * Interceptor incorporado el Framework CVF
 * registra el tiempo de ejecucin de una peticin CvfRequest
 * @author Adrian Chavero Ramos
 * @version 20 de dic. de 2015
 */
public class TimeEllapsedInterceptor extends CvfInterceptor {

	@Override
	public boolean interceptPreProcess(CvfRequestInvocation invocation) {
		invocation.getRequest().setAttribute("startMillisTimeEllapsedInterceptor", System.currentTimeMillis());
		return true;
	}

	@Override
	public void interceptPostProcess(CvfRequestInvocation invocation) {
		Long startMillisTimeEllapsedInterceptor = (Long)invocation.getRequest().getAttribute("startMillisTimeEllapsedInterceptor");
		Long ellapsedMillis = System.currentTimeMillis() - startMillisTimeEllapsedInterceptor;
		System.out.println("(TimeEllapsedInterceptor) Invocation time ellapsed: "
				+ invocation.getRequest().getRequestURI() + " " + ellapsedMillis + "ms" );
	}

}
