package com.achavero.cvf.views;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Anotaciones en los getters de los JavaBeans
 * usadas por el framework a la hora de mostrar una propiedad en un formulario
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
public @interface ColumnData {
	// Etiqueta idioma asociada al getter
	public String labelValue() default "";
	// Etiquete multiidioma asociada al getter
	public int labelIndex() default -1;
	// Numero de decimales, si el getter retorna un numero
	public int numDec() default 2;
	// Es el property obligatario en un formulario
	public boolean mandatory() default false;
}
