package com.achavero.cvf.views;

import java.lang.reflect.Method;

import org.apache.commons.lang.StringUtils;

/**
 * Helper para recuperar anotaciones de los getters
 * @author Adrian Chavero Ramos
 * @version 20 de dic. de 2015
 */
public class ColumnDataHelper {
	public static String getLabel(Object o, String property) {
		String propertyGetter = "get" + StringUtils.capitalize(property);
		Method objectPropertyGetter;
		try {
			objectPropertyGetter = o.getClass().getMethod(propertyGetter);
		} catch (NoSuchMethodException | SecurityException | NullPointerException e) {
			return "";
		}
		String labelValueAnnotation = "";
		ColumnData columnDataAnnotation = objectPropertyGetter.getAnnotation(ColumnData.class);
		if (columnDataAnnotation != null) {
			labelValueAnnotation = columnDataAnnotation.labelValue();
		}
		return labelValueAnnotation;
	}

	public static String getLabel(Class<?> c, String property) {
		String propertyGetter = "get" + StringUtils.capitalize(property);
		Method objectPropertyGetter;
		try {
			objectPropertyGetter = c.getMethod(propertyGetter);
		} catch (NoSuchMethodException | SecurityException | NullPointerException e) {
			return "";
		}
		String labelValueAnnotation = "";
		ColumnData columnDataAnnotation = objectPropertyGetter.getAnnotation(ColumnData.class);
		if (columnDataAnnotation != null) {
			labelValueAnnotation = columnDataAnnotation.labelValue();
		}
		return labelValueAnnotation;
	}
}
