package com.achavero.utils;

import java.util.LinkedList;
import java.util.List;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Clase de utilidad para tratar con XMLs
 * @author Adrian Chavero Ramos
 * @version 20 de dic. de 2015
 */
public class XMLutils {
	public static void removeEmptyNodes(Node node) {

		NodeList list = node.getChildNodes();
		List<Node> nodesToRecursivelyCall = new LinkedList();

		for (int i = 0; i < list.getLength(); i++) {
			nodesToRecursivelyCall.add(list.item(i));
		}

		for (Node tempNode : nodesToRecursivelyCall) {
			XMLutils.removeEmptyNodes(tempNode);
		}

		boolean emptyElement = node.getNodeType() == Node.ELEMENT_NODE && node.getChildNodes().getLength() == 0;
		boolean emptyText = node.getNodeType() == Node.TEXT_NODE && node.getNodeValue().trim().isEmpty();

		if (emptyElement || emptyText) {
			if (!node.hasAttributes()) {
				node.getParentNode().removeChild(node);
			}
		}

	}
}
