<%@tag import="com.achavero.cvf.views.ColumnData"%>
<%@tag import="org.apache.commons.lang.ClassUtils"%>
<%@ tag import="java.util.HashMap"%>
<%@ tag import="java.time.format.DateTimeFormatter"%>
<%@ tag import="java.time.ZoneOffset"%>
<%@ tag import="java.time.Instant"%>
<%@ tag import="java.time.LocalDateTime"%>
<%@ tag import="java.util.Date"%>
<%@ tag import="java.lang.reflect.InvocationTargetException"%>
<%@ tag import="java.lang.reflect.Method"%>

<%@ attribute name="fieldName" required="true" description="la propiedad del bean"%>
<%@ attribute name="entity" type="Object" required="false" description="la instancia del bean"%>
<%@ attribute name="selectedValue" required="false" description="valor seleccionado"%>
<%@ attribute name="serviceClassName" required="false" description="servicio que retorna la lista de valores posibles TODO"%>

<%@ attribute name="label" required="false" description="etiqueta multiidioma"%>
<%@ attribute name="mandatory" required="false" description="es el campo obligatorio"%>
<%@ attribute name="withLabel" required="false" description="esta la etiqueta multiidioma visible"%>
<%@ attribute name="inputType" required="false" description="html input type"%>
<%@ attribute name="readonly" required="false" description="read only input"%>
<%@ attribute name="checked" required="false" description="checked only input checkbox"%>

<%
	// START initialization
	if (entity == null) {
		entity = request.getAttribute("mantFieldEntity");
	}

	if (selectedValue == null) {
		selectedValue = "";
	}

	if (mandatory == null) {
		mandatory = "false";
	}

	if (withLabel == null) {
		withLabel = "true";
	}

	if (label == null) {
		label = "";
	}

	if (readonly == null) {
		readonly = "false";
	}

	if (checked == null) {
		checked = "false";
	}
	// END initialization

	// START method return value + metadata (annotations)
	String entityPropertyValue = "";
	HashMap<String, String> entityPropertiesValuesMap = new HashMap<>();
	String labelValueAnnotation = "";
	int fieldLengthAnnotation = -1;
	int fieldNumDecAnnotation = -1;
	Class<?> entityPropertyType = Object.class;

	try {
		// entity property getter
		Method entityPropertyGetter = null;
		try {
			entityPropertyGetter = entity.getClass().getMethod("get" + fieldName.substring(0, 1).toUpperCase()
			        + fieldName.substring(1, fieldName.length()));
		} catch (NoSuchMethodException e) {
			entityPropertyGetter = entity.getClass().getMethod("is" + fieldName.substring(0, 1).toUpperCase()
			        + fieldName.substring(1, fieldName.length()));
		}
		// entity property type
		entityPropertyType = entityPropertyGetter.getReturnType();

		// entity property value
		Object entityPropertyObject = entityPropertyGetter.invoke(entity);
		if (entityPropertyType == Date.class) {
			if (entityPropertyObject == null) {
				entityPropertyValue = "";
			} else {
				entityPropertyValue = LocalDateTime
				        .ofInstant(Instant.ofEpochMilli(((Date) entityPropertyObject).getTime()),
				                ZoneOffset.of("+1"))
				        .format(DateTimeFormatter.ofPattern("dd/MM/yyyy HH:mm"));
			}
		} else {
			if (entityPropertyObject == null) {
				entityPropertyValue = "";
			} else {
				entityPropertyValue = entityPropertyObject.toString();
			}
		}

		// custom annotations (to get label and mandatory)
		ColumnData columnDataAnnotation = entityPropertyGetter.getAnnotation(ColumnData.class);
		if (columnDataAnnotation != null) {
			labelValueAnnotation = columnDataAnnotation.labelValue();
			if (columnDataAnnotation.mandatory()) {
				mandatory = "true"; 
			}
			fieldNumDecAnnotation = columnDataAnnotation.numDec();
		}

	} catch (NoSuchMethodException | IllegalAccessException | IllegalArgumentException
	        | InvocationTargetException e) {
		System.err.println(e);
	}

	if (label.equals("") && !labelValueAnnotation.equals("")) {
		label = labelValueAnnotation;
	}

	if (inputType == null) {
		if ((entityPropertyType.isPrimitive() ? ClassUtils.primitiveToWrapper(entityPropertyType)
		        : entityPropertyType) == Boolean.class) {
			inputType = "checkbox";
		} else {
			inputType = "text";
		}
	}

if (inputType.equals("hidden")) { %>
	<input type="hidden" id="<%=fieldName%>" name="<%=fieldName%>" value="<%=entityPropertyValue%>">
<% } else if (serviceClassName != null) { %>
<%
	} else {
	// START property in input
%>
	<div class="form-group">
	<% 
	if (withLabel.equalsIgnoreCase("true")) { %>
		<label class="col-sm-4 control-label text-right" for="<%=fieldName%>"> <%
 		if (mandatory.equalsIgnoreCase("true")) {
 			%><span class="obligatori">*</span> <%
 		}
 		%><%=label%>
		</label>
	<% } %>
	<div class="col-sm-8">
		<% if (inputType.equals("text")) { %>
			<input
				id="<%=fieldName%>"
				name="<%=fieldName%>"
				placeholder="<%=label%>"
				type="text" <%if (readonly.equals("true")) {%> readonly <%}%>
				class="form-control"
				<% if (entityPropertyType == Date.class) { %>
					style="width: 160px; float:left;"
				<% } else { %>
					style="width: 100%;"
				<% } %>
				<%if (entityPropertyType == Double.class) {
					if (entityPropertyValue == null || entityPropertyValue.toString().equals("")) { %>
						value="" 
					<%} else {%>
						value="<%=(Math.round(Double.parseDouble(entityPropertyValue.toString()) * fieldNumDecAnnotation * 10d ) / fieldNumDecAnnotation * 10d)%>"
					<%}
				} else { %> 
					value="<%=entityPropertyValue%>" 
				<% } %>
				
				<%if (mandatory.equalsIgnoreCase("true")) {%>
				data-bv-notempty="true"
				<%}
				if (entityPropertyType == Integer.class) {%>
				data-bv-integer="true"
				<%}
				if (entityPropertyType == Double.class) {%>
				data-bv-numeric="true"
				<%}
				if (entityPropertyType == String.class) {
					if (fieldLengthAnnotation > -1) {%>
						data-bv-stringlength="true"
						data-bv-stringlength-max="<%=fieldLengthAnnotation%>" 
					<%}
				}%>>
			<% if (entityPropertyType == Date.class) { %>
				<span class="input-group-addon" style="cursor: pointer; width: 34px; height: 34px; float: left;">
					<i class="fa fa-calendar"></i>
				</span>
			<% } 
		} else if (inputType.equals("textarea")) {
		%>
			<textarea id="<%=fieldName%>" name="<%=fieldName%>"
				class="form-control forceborderradius" maxlength="<%if (fieldLengthAnnotation > -1) {%><%=fieldLengthAnnotation%><%}%>"
				<%if (readonly.equals("true")) {%> readonly <%}%>><%=entityPropertyValue%></textarea>
		<% } else if (inputType.equals("checkbox")) {
			Boolean fieldValueBoolean = Boolean.parseBoolean(entityPropertyValue.toString());
			%>
			<input
				id="<%=fieldName%>"
				name="<%=fieldName%>"
				type="checkbox" <%=(fieldValueBoolean ? "checked" : "")%>
				value="true" <%if (checked.equals("true")) {%> checked <%}%>
				<%if (readonly.equals("true")) { %>
					onchange="this.checked=!this.checked;" 
				<% } %>>
		<% } else if (inputType.equals("password")) { %>
			<input id="<%=fieldName%>" name="<%=fieldName%>"
				class="form-control" type="password" placeholder="<%=label%>" value="<%=entityPropertyValue%>"> 
		<% } %>
		</div>
	</div>
<%
//END property in input
}
%>
